<template>
  <div class="background">
    <v-container>
      <v-form @submit.prevent="getUserList()">
        <div class="d-flex">
          <div class="account-search flex-grow-1">
            <v-text-field
              class="account-search__field"
              label="Поиск игроков"
              outlined
              v-model="search"
              dark
              background-color="grey darken-3"
              hide-details
            >
            </v-text-field>
            <div v-if="suggestions.length" class="account-search__hint">
              <v-list>
                <v-list-item
                  @click="openUserAccount(item)"
                  v-for="item in suggestions"
                  :key="item.value"
                >
                  {{ item.label }}
                </v-list-item>
              </v-list>
            </div>
          </div>
          <v-btn depressed height="auto" type="submit">
            <v-icon dark>
              mdi-magnify
            </v-icon>
          </v-btn>
        </div>
      </v-form>
      <div class="mt-5" v-if="players.length">
        <v-data-table :headers="headers" :items="players" class="elevation-1">
          <template v-slot:[`item.name`]="{ item }">
            <a class="link" target="_blank" :href="`https://worldofwarships.ru/ru/community/accounts/${item.value}-${item.name}`">
              {{ item.name }}
            </a>
          </template>
        </v-data-table>
      </div>
      <v-alert border="left" color="grey darken-2" dark v-if="searchError">
        {{ searchError }}
      </v-alert>
    </v-container>
  </div>
</template>
<script>
import service from "../service";

export default {
  name: "accounts",
  components: {},
  data() {
    return {
      search: "",
      searchError: "",
      suggestions: [],
      headers: [
        { text: "Имя пользователя", value: "name" },
        { text: "Бои", value: "battles" },
        { text: "Победы", value: "wins" },
      ],
      players: [],
    };
  },
  watch: {
    search(val) {
      this.getUsernameSuggestions(val);
    },
  },
  methods: {
    getUsernameSuggestions(val) {
      if (val.trim().length < 3) {
        return (this.suggestions = []);
      }
      service.getUsernameSuggestions(val).then((result) => {
        this.suggestions = result.slice(0, 10);
      });
    },
    openUserAccount(user) {
      window.open(
        `https://worldofwarships.ru/ru/community/accounts/${user.value}-${user.label}`
      );
    },
    getUserList() {
      document.activeElement.blur();
      this.searchError = "";
      const val = this.search;
      service.getUserList(val).then((result) => {
        if (!result.length) {
          this.searchError = "Подходящих аккаунтов не найдено.";
        }
        this.players = result;
      });
    },
  },
};
</script>
<style>
.account-search {
  position: relative;
}
.account-search__field.v-input--is-focused + .account-search__hint {
  opacity: 1;
  visibility: visible;
}
.account-search__hint {
  opacity: 0;
  visibility: hidden;
  position: absolute;
  top: 100%;
  width: 100%;
  background-color: #757575;
  color: #fff;
  transition: all 0.3s ease;
}
.account-search__hint .v-list-item {
  min-height: auto;
}
.v-application a.link {
  text-decoration: none;
  font-size: 16px;
  color: #272727;
  font-weight: bold;
}
.v-application a.link:hover {
  color: indigo;
}
</style>
